from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, String, Int

Gem_2_Bed_Blocks_Coverage_V0_1_0 = CommandToolBuilder(tool="gem_2_bed_blocks_coverage", base_command=["gem-2-bed", "blocks-coverage"], inputs=[ToolInput(tag="in_index", input_type=File(optional=True), prefix="--index", doc=InputDocumentation(doc="(mandatory)")), ToolInput(tag="in_input", input_type=File(optional=True), prefix="--input", doc=InputDocumentation(doc="(default=stdin)")), ToolInput(tag="in_mapped_ends", input_type=Boolean(optional=True), prefix="--mapped-ends", doc=InputDocumentation(doc="'none'|'1'|'2'|<integer>\n(default=2)")), ToolInput(tag="in_subtract_ns_from_error", input_type=Boolean(optional=True), prefix="--subtract-Ns-from-error", doc=InputDocumentation(doc="'false'|'true'\n(default: true)")), ToolInput(tag="in_subtract_splices_from_error", input_type=Boolean(optional=True), prefix="--subtract-splices-from-error", doc=InputDocumentation(doc="'false'|'true'\n(default: true)")), ToolInput(tag="in_max_errors", input_type=Boolean(optional=True), prefix="--max-errors", doc=InputDocumentation(doc="'none'|<integer_or_fraction>\n(default=0.06)")), ToolInput(tag="in_min_splice_size", input_type=Boolean(optional=True), prefix="--min-splice-size", doc=InputDocumentation(doc="'none'|<integer>\n(default=1)")), ToolInput(tag="in_max_splice_size", input_type=Boolean(optional=True), prefix="--max-splice-size", doc=InputDocumentation(doc="'none'|<integer>\n(default: none)")), ToolInput(tag="in_min_strata", input_type=Boolean(optional=True), prefix="--min-strata", doc=InputDocumentation(doc="'none'|<integer_or_fraction>\n(default=1)")), ToolInput(tag="in_max_strata", input_type=Boolean(optional=True), prefix="--max-strata", doc=InputDocumentation(doc="'none'|<integer_or_fraction>\n(default=1)")), ToolInput(tag="in_max_matches", input_type=Boolean(optional=True), prefix="--max-matches", doc=InputDocumentation(doc="'none'|<integer>   (default: none)")), ToolInput(tag="in_directional_as_end", input_type=Boolean(optional=True), prefix="--directional-as-end", doc=InputDocumentation(doc="'none'|1'|'2'|<integer>\n(default: none)")), ToolInput(tag="in_full_filter", input_type=String(optional=True), prefix="--full-filter", doc=InputDocumentation(doc="(default: see above,\n'-F help' shows syntax)")), ToolInput(tag="in_strand_from_current_block", input_type=Boolean(optional=True), prefix="--strand-from-current-block", doc=InputDocumentation(doc="'forward'|'reverse'\n(default: none)")), ToolInput(tag="in_strand_from_first_block", input_type=Boolean(optional=True), prefix="--strand-from-first-block", doc=InputDocumentation(doc="'forward'|'reverse'\n(default: none)")), ToolInput(tag="in_strand_from_splices", input_type=Boolean(optional=True), prefix="--strand-from-splices", doc=InputDocumentation(doc="'forward'|'reverse'\n(default: none)")), ToolInput(tag="in_threshold", input_type=Boolean(optional=True), prefix="--threshold", doc=InputDocumentation(doc="(default=0.1)")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="(mandatory)")), ToolInput(tag="in_scale", input_type=Boolean(optional=True), prefix="--scale", doc=InputDocumentation(doc="'linear'|'log'|'log'<int>|'root'<int>\n(default='linear')")), ToolInput(tag="in_levels_per_scale_unit", input_type=Int(optional=True), prefix="--levels-per-scale-unit", doc=InputDocumentation(doc="(quantize levels,\ndefault: disabled)")), ToolInput(tag="in_back_transform", input_type=Boolean(optional=True), prefix="--back-transform", doc=InputDocumentation(doc="(invert scale transformation)\nafter quantization,\ndefault: disabled)")), ToolInput(tag="in_precision_digits", input_type=Int(optional=True), prefix="--precision-digits", doc=InputDocumentation(doc="(default=6)")), ToolInput(tag="in_emit_zeros", input_type=Boolean(optional=True), prefix="--emit-zeros", doc=InputDocumentation(doc="(default=false)")), ToolInput(tag="in_max_buffer_size", input_type=Int(optional=True), prefix="--max-buffer-size", doc=InputDocumentation(doc="(default=1000000000)")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="(default=1)")), ToolInput(tag="in_gem_two_bed", input_type=Int(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_blocks_coverage_vertical_line_splices_coverage", input_type=String(), position=1, doc=InputDocumentation(doc=""))], outputs=[], container="quay.io/biocontainers/gem2:20200110--0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Gem_2_Bed_Blocks_Coverage_V0_1_0().translate("wdl")

